<?php
namespace Claromentis\Core\ORM\Behaviors;

$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"] ?: array()) + array("_c006f837e282" . "4506391e3088e" . "0b02cea" => base64_decode("IG9y" . "IA=="), "_d5aab080ef90d0e0aeec9b29c" . "03836f2" => base64_decode("TWV0YWRhdGEgbXVzdCBiZSBhbiBhcnJheSBvZiBtZXRhZGF0YSB2YWx1ZXMgb3IgYW4gaW5zdG" . "FuY2Ugb2Yg"), "metada" . "ta" => base64_decode("bWV0" . "YWRh" . "dGE="), "_7f628626dd1d55c7" . "1b1fc0932ffd1d2c" => base64_decode("aXNfYX" . "JyYXk="));
use Analogue\ORM\EntityCollection;
use Analogue\ORM\Mappable;
use Illuminate\Support\Collection;
use ProxyManager\Proxy\ProxyInterface;
use Claromentis\Core\ORM\Entity\Metadata as MetadataEntity;






















trait Metadata
{
    
    
    
    
    
    
    protected $metadata;
    
    
    
    
    
    
    public abstract function getMetadataAggregation() : int;
    
    
    
    
    
    
    public function getMetadataObjectId() : int
    {
        return $this->id;
    }
    
    
    
    
    
    
    public function getMetadataSetId() : int
    {
        return 0;
    }
    
    
    
    
    
    
    
    
    
    
    public function getMetadataAttribute($elements) : MetadataEntity
    {
        
        
        if (!$this->metadata) {
            $aggregation = $this->getMetadataAggregation();
            $object_id = $this->getMetadataObjectId();
            $set_id = $this->getMetadataSetId();
            $this->metadata = new MetadataEntity($this, $aggregation, $object_id, $set_id);
            $this->metadata->elements = $elements ?: new EntityCollection();
        }
        return $this->metadata;
    }
    
    
    
    
    
    
    
    
    
    public function setMetadataAttribute($metadata)
    {
        if (!$metadata instanceof MetadataEntity && !$metadata instanceof Collection && !$GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_7f628626dd1d55c71b1fc0932ffd1d" . "2c"]($metadata)) {
            throw new \InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_d5aab080ef90d0e0aeec9b29c0" . "3836f2"] . Collection::class . $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_c006f837e2824506391" . "e3088e0b02cea"] . MetadataEntity::class);
        }
        
        
        if ($metadata instanceof MetadataEntity) {
            $this->attributes[$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["meta" . "data"]] = $metadata->getElements()->flatten()->filter();
        }
        if ($metadata instanceof Collection) {
            $this->attributes[$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["metada" . "ta"]] = $metadata->flatten()->filter();
        }
        
        
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_7f628626dd1d55c71b1fc0932ff" . "d1d2c"]($metadata)) {
            $metadataEntity = $this->getMetadataAttribute(null);
            $metadataEntity->setValues($metadata);
        }
    }
}